
Ruby - Feature #3348

rubyspec: Kernel.spawn redirects both STDERR and STDOUT  to the given name ERROR

05/27/2010 05:14 AM - mame (Yusuke Endoh)

Status: Closed   

Priority: Normal   

Assignee: mame (Yusuke Endoh)   

Target version: 2.2.0   

Description

=begin

遠藤です。

spawn のリダイレクトの引数で :out => "foo" としたとき、ファイル foo が存在

しなければ作ってくれますが、[:out, :err] => "foo" だと作ってくれません。

ruby -e 'pid = spawn("echo", "foo", [:out, :err] => "foo"); Proces.wait pid'

これは意図的でしょうか。

うっとうしいことに、rubyspec がこの挙動に依存して失敗するようになりました。

配列の中がすべて :out か :err だったら O_CREAT|O_TRUNC にするパッチです。

反対がなければコミットします。

diff --git a/process.c b/process.c

index 9e52392..4ca6ed3 100644

--- a/process.c

+++ b/process.c

@@ -1342,7 +1342,19 @@ check_exec_redirect(VALUE key, VALUE val, VALUE options)

key = check_exec_redirect_fd(key);

if (FIXNUM_P(key) && (FIX2INT(key) == 1 || FIX2INT(key) == 2))

flags = INT2NUM(O_WRONLY|O_CREAT|O_TRUNC);

   else

   else if (TYPE(key) == T_ARRAY) {

 int i;

 for (i = 0; i < RARRAY_LEN(key); i++) {

 VALUE v = RARRAY_PTR(key)[i];

 VALUE fd = check_exec_redirect_fd(v);

 if (FIX2INT(fd) != 1 && FIX2INT(fd) != 2) break;

 }

 if (i == RARRAY_LEN(key))

 flags = INT2NUM(O_WRONLY|O_CREAT|O_TRUNC);

 else

 flags = INT2NUM(O_RDONLY);

}

else

flags = INT2NUM(O_RDONLY);

perm = INT2FIX(0644);

param = hide_obj(rb_ary_new3(3, hide_obj(rb_str_dup(path)),
--

Yusuke Endoh mame@tsg.ne.jp

=end

Associated revisions

Revision 7a69a3583c2235c0ad3ad0705aa2f08cbe2d76bb - 05/05/2014 01:37 PM - akr (Akira Tanaka)

process.c (check_exec_redirect): Open the file in write mode for

redirect from [:out, :err].

Proposed and implemented by Yusuke Endoh.

[ruby-dev:41430] [Feature #3348]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@45828 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 7a69a358 - 05/05/2014 01:37 PM - akr (Akira Tanaka)

process.c (check_exec_redirect): Open the file in write mode for

redirect from [:out, :err].

Proposed and implemented by Yusuke Endoh.

[ruby-dev:41430] [Feature #3348]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@45828 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 05/27/2010 06:54 AM - akr (Akira Tanaka)

=begin

2010年5月27日5:14 Yusuke ENDOH mame@tsg.ne.jp:

spawn のリダイレクトの引数で :out => "foo" としたとき、ファイル foo が存在

しなければ作ってくれますが、[:out, :err] => "foo" だと作ってくれません。

ruby -e 'pid = spawn("echo", "foo", [:out, :err] => "foo"); Proces.wait pid'

これは意図的でしょうか。

うっとうしいことに、rubyspec がこの挙動に依存して失敗するようになりました。

配列の中がすべて :out か :err だったら O_CREAT|O_TRUNC にするパッチです。

反対がなければコミットします。

 

その挙動は悪くないと思いますが、1.9.1 と非互換ですねぇ。

[田中 哲][たなか あきら][Tanaka Akira]

=end

#2 - 05/27/2010 06:09 PM - mame (Yusuke Endoh)

=begin

遠藤です。

2010年5月27日6:54 Tanaka Akira akr@fsij.org:

配列の中がすべて :out か :err だったら O_CREAT|O_TRUNC にするパッチです。

反対がなければコミットします。

 その挙動は悪くないと思いますが、1.9.1 と非互換ですねぇ。

 うーん。そうですねえ。

:out => "foo", :err => "foo" はどうなるべきかとか、[:in, :out] => "foo"

には何を期待するのかとか、仕様レベルで検討しないと行けない気がしてきたの

で、ここだけ焦って直す必要はない気がしてきました。

このチケットは 1.9.x にして、今は rubyspec 側を修正しておきます。

--

Yusuke Endoh mame@tsg.ne.jp
=end

#3 - 06/26/2011 02:57 PM - naruse (Yui NARUSE)

- Status changed from Open to Assigned

- Assignee set to akr (Akira Tanaka)

- Target version set to 2.0.0

- ruby -v set to 1.9

#4 - 02/18/2013 09:10 PM - mame (Yusuke Endoh)

- Target version changed from 2.0.0 to 2.6

ちゃんとチケット整理しなかったからまた直す機会を逸してしまった。すみません。

--

Yusuke Endoh mame@tsg.ne.jp

#5 - 04/07/2013 12:01 AM - akr (Akira Tanaka)

- Assignee changed from akr (Akira Tanaka) to mame (Yusuke Endoh)

この機能ですが、Ruby 2.1 で minor incompatibilities を許容するならそろそろ入れてもいいんじゃないでしょうか。

#6 - 04/07/2013 01:00 AM - akr (Akira Tanaka)

- Tracker changed from Bug to Feature

#7 - 04/07/2013 01:14 AM - kosaki (Motohiro KOSAKI)

この機能ですが、Ruby 2.1 で minor incompatibilities を許容するならそろそろ入れてもいいんじゃないでしょうか。

 わたしも入れていいと思います。

#8 - 04/07/2013 09:34 PM - naruse (Yui NARUSE)

- Target version changed from 2.6 to 2.1.0

#9 - 01/30/2014 06:16 AM - hsbt (Hiroshi SHIBATA)

- Target version changed from 2.1.0 to 2.2.0

#10 - 05/05/2014 01:37 PM - akr (Akira Tanaka)

- Status changed from Assigned to Closed

- % Done changed from 0 to 100

Applied in changeset r45828.

process.c (check_exec_redirect): Open the file in write mode for

redirect from [:out, :err].

Proposed and implemented by Yusuke Endoh.

[ruby-dev:41430] [Feature #3348]
